<template>
    <div class="knowledge-container row justify-start q-py-lg">
        <div
            class="
                col-11 col-md-2 col-lg-2
                q-pt-md
                knowledge-category
                q-ml-md q-mr-md
            "
        >
            <!-- <div
                class="col-12 row justify-center q-pb-sm pointer"
                @click="unselectCategory"
            >
                <q-icon class="font-28" name="arrow_upward" />
                <span class="items-center helvetica-neue-medium font-18">
                    up
                </span>
            </div> -->
            <div
                class="
                    col-12 col-md-7
                    colomn
                    justify-center
                    category-btns
                    q-ma-md q-mb-lg
                "
            >
                <q-btn
                    no-caps
                    color="primary"
                    text-color="white"
                    :label="$t('preference.rootCategory')"
                    class="
                        helvetica-neue-medium
                        font-12
                        btn-category
                        border-radius-10
                    "
                    @click="unselectCategory"
                />
            </div>
            <div v-if="state.innerShow == false">
                <div
                    class="
                        col-12 col-md-7
                        colomn
                        justify-center
                        category-btns
                        q-ma-md
                    "
                    v-for="(category, index) in state.parentCategory"
                    :key="category.id"
                >
                    <q-btn
                        no-caps
                        color="primary"
                        text-color="white"
                        class="
                            helvetica-neue-medium
                            font-12
                            btn-category
                            border-radius-10
                        "
                        :label="category.name"
                        @click="selectCategory(category, index)"
                    />
                </div>
            </div>
            <div v-else-if="state.innerShow == true">
                <div
                    class="
                        col-12 col-md-7
                        colomn
                        justify-center
                        category-btns
                        q-ma-md
                    "
                    v-for="category in state.parentCategory[state.indexParent]
                        .nestedChild"
                    :key="category.id"
                >
                    <q-btn
                        no-caps
                        color="primary"
                        text-color="white"
                        class="
                            helvetica-neue-medium
                            font-16
                            btn-category
                            border-radius-10
                        "
                        :label="category.name"
                        @click="selectInnerCategory(category)"
                    />
                </div>
            </div>
            <div
                class="
                    col-12 col-md-7
                    column
                    justify-center
                    category-btns
                    q-ma-md q-pt-lg
                "
                v-if="permissions.knowledge?.create || business?.member.isOwner"
            >
                <q-btn
                    no-caps
                    color="primary"
                    text-color="white"
                    class="
                        helvetica-neue-medium
                        btn-category
                        border-radius-10
                        font-10
                    "
                    icon="img:icons\add-icon.png"
                    @click="categoryForm()"
                />
            </div>
        </div>
        <div
            class="col-11 col-md-2 col-lg-2 category-list q-mx-lg-xl q-mx-md-lg"
        >
            <div v-if="state.formCategory == false">
                <div
                    class="col-12 justify-start q-mb-lg"
                    v-if="state.edit != true"
                >
                    <p
                        class="
                            col-12
                            items-start
                            q-mt-md
                            helvetica-neue-medium
                            font-24
                        "
                    >
                        {{ state.text }}
                        <q-icon
                            class="q-ml-sm pointer"
                            name="img:icons\edit-icon-blue.png"
                            size="xs"
                            @click="editStatus"
                            v-if="permissions.knowledge?.update"
                        />
                        <q-icon
                            class="q-ml-sm pointer remove-btn"
                            name="delete"
                            @click="deleteCategoryName"
                            v-if="permissions.knowledge?.delete"
                        />
                    </p>
                </div>
                <div class="col-12 justify-start q-mb-sm" v-else>
                    <q-input
                        bg-color="white"
                        class="col-12 items-start helvetica-neue-medium font-24"
                        outlined
                        v-model="state.text"
                        label="Category"
                        input-class="category-list-btn"
                        @keyup.enter="editCategoryName"
                    />
                </div>
                <div
                    class="row col-12 q-pt-sm q-pb-sm category-btns"
                    v-for="knowledge in state.listKnowledge"
                    :key="knowledge.id"
                >
                    <q-btn
                        no-caps
                        color="primary"
                        text-color="white"
                        class="col-12 font-12 row btn-category border-radius-10"
                        :label="knowledge.title"
                        @click="selectChild(knowledge)"
                    />
                </div>
                <div class="row col-12 q-pt-lg q-pb-md category-btns">
                    <q-btn
                        no-caps
                        color="primary"
                        text-color="white"
                        class="col-12 row btn-category border-radius-10 font-10"
                        icon="img:icons\add-icon.png"
                        @click="newKnowledge"
                    />
                </div>
            </div>
            <div v-else-if="state.formCategory == true">
                <div class="col-12 justify-start q-mb-sm category-container">
                    <q-input
                        bg-color="white"
                        class="col-12 items-start helvetica-neue-medium font-24"
                        outlined
                        v-model="state.text"
                        label="Category"
                        input-class="category-list-btn"
                    />
                </div>
                <div
                    class="row col-12 q-pt-lg q-pb-md"
                    v-if="permissions.knowledge?.create"
                >
                    <q-btn
                        no-caps
                        color="primary"
                        text-color="white"
                        class="col-12 row btn-category border-radius-10 font-10"
                        icon="img:icons\add-icon.png"
                        @click="addCategory"
                    />
                </div>
            </div>
        </div>
        <div
            class="category-list col-md-6 col-11 q-ml-md q-mr-md justify-center"
            v-if="state.editKnowledge == true"
        >
            <div class="col-12 justify-start q-mb-sm category-container">
                <q-input
                    bg-color="white"
                    class="col-12 items-start helvetica-neue-medium font-24"
                    outlined
                    v-model="state.selectedKnowledge.title"
                    label="Title"
                    input-class="category-list-btn"
                />
            </div>
            <div class="col-12 justify-start justify-center q-mb-sm">
                <!-- <q-editor
                    v-model="state.selectedKnowledge.content"
                    class="text-editor"
                    :definitions="{
                        bold: {
                            label: 'Bold',
                            icon: null,
                            tip: 'My bold tooltip'
                        }
                    }"
                /> -->
                <q-editor
                    v-model="state.selectedKnowledge.content"
                    class="text-editor"
                    placeholder="Type your text here.."
                    :toolbar="[
                        ['bold', 'italic', 'underline'],
                        [
                            {
                                label: $q.lang.editor.fontSize,
                                icon: $q.iconSet.editor.fontSize,
                                fixedLabel: true,
                                fixedIcon: true,
                                list: 'no-icons',
                                options: [
                                    'size-1',
                                    'size-2',
                                    'size-3',
                                    'size-4',
                                    'size-5',
                                    'size-6',
                                    'size-7'
                                ]
                            }
                        ],
                        ['unordered']
                    ]"
                />
            </div>
            <div class="col-12 float-right q-my-sm">
                <q-btn
                    no-caps
                    text-color="white"
                    class="
                        helvetica-neue-medium
                        btn-category
                        button-delete
                        q-mr-md
                        border-radius-10
                    "
                    @click="deleteKnowledge()"
                    label="Delete"
                />
                <q-btn
                    no-caps
                    text-color="white"
                    class="
                        helvetica-neue-medium
                        btn-category
                        button-save
                        border-radius-10
                    "
                    @click="editKnowledge()"
                    label="Save Change"
                />
            </div>
        </div>
        <div
            class="category-list col-md-6 col-11 q-ml-md q-mr-xl"
            v-else-if="state.editKnowledge == false"
        >
            <div class="col-12 justify-start q-mb-sm">
                <q-input
                    bg-color="white"
                    class="col-12 items-start helvetica-neue-medium font-24"
                    outlined
                    v-model="state.title"
                    label="Title"
                    input-class="category-list-btn"
                />
            </div>
            <div class="col-12 justify-start q-mb-sm">
                <!-- <q-editor
                    v-model="state.content"
                    class="text-editor"
                    :definitions="{
                        bold: {
                            label: 'Bold',
                            icon: null,
                            tip: 'My bold tooltip'
                        }
                    }"
                /> -->
                <q-editor
                    v-model="state.content"
                    class="text-editor"
                    placeholder="Type your text here.."
                    :toolbar="[
                        ['bold', 'italic', 'underline'],
                        [
                            {
                                label: $q.lang.editor.fontSize,
                                icon: $q.iconSet.editor.fontSize,
                                fixedLabel: true,
                                fixedIcon: true,
                                list: 'no-icons',
                                options: [
                                    'size-1',
                                    'size-2',
                                    'size-3',
                                    'size-4',
                                    'size-5',
                                    'size-6',
                                    'size-7'
                                ]
                            }
                        ],
                        ['unordered']
                    ]"
                />
            </div>
            <div class="col-12 float-right q-mb-sm">
                <q-btn
                    no-caps
                    color="green"
                    text-color="white"
                    class="helvetica-neue-medium btn-category border-radius-10"
                    @click="addKnowledge()"
                    label="Save Change"
                />
            </div>
        </div>
    </div>
</template>

<script lang="ts">
/* eslint-disable @typescript-eslint/no-misused-promises */

import { useStore } from 'src/store';
import {
    defineComponent,
    ref,
    computed,
    watch,
    reactive,
    onMounted
} from 'vue';
import { debounce } from 'lodash';
import { mapGetters } from 'vuex';

export default defineComponent({
    name: 'KnowledgeBase',
    computed: {
        ...mapGetters({
            permissions: 'role/getPermissions',
            business: 'business/getBusiness'
        })
    },
    setup() {
        const store = useStore();
        const selectedBusinessId = computed(() => {
            return store.state.business.businessID;
        });
        const search = ref('');

        let state = reactive({
            selectedCategory: '',
            selectedCategoryChild: [] as any,
            text: '',
            text2: '',
            categoryId: '',
            title: '' as any,
            content: '' as any,
            indexParent: 0,
            innerShow: ref(false),
            edit: ref(false),
            editKnowledge: ref(),
            formCategory: ref(),
            parentCategory: [] as any,
            childCategory: [] as any,
            knowledge: [] as any,
            listKnowledge: [] as any,
            listCategory: [] as any,
            selectedKnowledge: {} as any,
            editCategory: {} as any
        });

        watch(selectedBusinessId, () => {
            state.parentCategory = [];
            unselectCategory();
            getCategory();
        });

        const select = (userID: string) => {
            state.selectedCategory = userID;
        };

        const editStatus = () => {
            state.edit = true;
        };
        const selectChild = (knowledge: any) => {
            if (state.selectedKnowledge != null) {
                state.selectedKnowledge = {};
            }
            state.selectedCategoryChild = knowledge.category;
            state.selectedKnowledge = knowledge;
            knowledgeShow();
        };

        const selectCategory = (category: any, index: number) => {
            state.listKnowledge = [];
            state.text = category.name;
            state.text2 = category.name;
            state.editCategory = [category];
            state.listCategory.push(category);
            state.innerShow = true;
            state.indexParent = index;
            filterKnowledge();
            state.formCategory = false;
        };
        const selectInnerCategory = (category: any) => {
            /* state.listCategory = [];
            if (state.listCategory[1]) {
                state.listCategory.splice(1, 2);
                state.listKnowledge = [];
            } */

            if (state.editCategory != null) {
                state.editCategory = {};
            }
            state.text = category.name;
            state.text2 = category.name;
            state.editCategory = [category];
            filterKnowledge();
            state.formCategory = false;
        };

        const unselectCategory = () => {
            state.innerShow = false;
            state.formCategory = null;
            state.editKnowledge = null;
            state.indexParent = 0;
            state.listCategory = [];
            state.listKnowledge = [];
            state.editCategory = {};
            state.text = '';
            state.text2 = '';
            state.selectedKnowledge = {};
        };

        const categoryForm = () => {
            state.formCategory = true;
        };

        const knowledgeShow = () => {
            state.editKnowledge = true;
        };

        const newKnowledge = () => {
            state.editKnowledge = false;
        };

        const addCategory = debounce(async () => {
            if (state.listCategory[0]) {
                state.categoryId = state.listCategory[0].id;
            } else {
                state.categoryId = '';
            }

            const res = await store.dispatch('category/createCategory', {
                name: state.text,
                parentId: state.categoryId
            });
            if (res) {
                state.parentCategory = [];
                state.formCategory = null;

                state.text = state.text2;
                getCategory();
            }
        }, 500);

        const editCategoryName = async () => {
            if (store.state.role.permissions.knowledge?.update) {
                const res = await store.dispatch('category/updateCategory', {
                    name: state.text,
                    knowledgebaseCategoryId: state.editCategory[0].id
                });
                if (res) {
                    state.parentCategory = [];
                    unselectCategory();
                    getCategory();
                    state.edit = false;
                }
            }
        };
        const deleteCategoryName = async () => {
            const res = await store.dispatch('category/deleteCategory', {
                knowledgebaseCategoryId: state.editCategory[0].id
            });
            if (res) {
                state.parentCategory = [];
                unselectCategory();
                getCategory();
            }
        };

        const addKnowledge = async () => {
            const res = await store.dispatch('category/createKnowledgeBase', {
                /* knowledgebaseId : id, */
                title: state.title,
                content: state.content,
                knowledgebaseCategoryId: state.editCategory[0].id
            });
            if (res) {
                state.parentCategory = [];
                state.listKnowledge = [];
                unselectCategory();
                getCategory();
                getKnowledge();
                filterKnowledge();
                state.editKnowledge = null;
            }
        };

        const editKnowledge = async () => {
            const res = await store.dispatch('category/updateKnowledgeBase', {
                title: state.selectedKnowledge.title,
                content: state.selectedKnowledge.content,
                knowledgebaseId: state.selectedKnowledge.id
            });
            if (res) {
                state.parentCategory = [];
                state.listKnowledge = [];
                unselectCategory();
                getCategory();
                getKnowledge();
                filterKnowledge();
                state.editKnowledge = null;
            }
        };
        const deleteKnowledge = async () => {
            const res = await store.dispatch('category/deleteKnowledgeBase', {
                knowledgebaseId: state.selectedKnowledge.id
            });
            if (res) {
                state.parentCategory = [];
                state.listKnowledge = [];
                unselectCategory();
                getCategory();
                getKnowledge();
                filterKnowledge();
                state.editKnowledge = null;
            }
        };

        const getCategory = async () => {
            const result: any = await store.dispatch('category/getCategory');

            if (result.result.categories.length > 0) {
                /* state.category = result.result.categories; */
                result.result.categories.forEach((element: any) => {
                    if (!element.parentId) {
                        let category = {
                            id: element.id,
                            businessId: element.businessId,
                            name: element.name,
                            slug: element.slug,
                            nestedChild: [] as any
                        };
                        state.parentCategory.push(category);
                    }
                });
                result.result.categories.forEach((element: any) => {
                    state.parentCategory.forEach(
                        (element2: any, index2: any) => {
                            if (element.parentId == element2.id) {
                                state.parentCategory[index2][
                                    'nestedChild'
                                ].push(element);
                            } else {
                                return false;
                            }
                        }
                    );
                });
            }
        };

        const getKnowledge = async () => {
            const result: any = await store.dispatch(
                'category/getKnowledgeBase',
                { businessId: store.state.business.businessID }
            );

            if (result.result.knowledgebases.length > 0) {
                state.knowledge = result.result.knowledgebases;
            }
        };

        const filterKnowledge = () => {
            if (state.knowledge) {
                state.listKnowledge = [];
                state.knowledge.forEach((element: any) => {
                    state.listCategory.forEach((element2: any) => {
                        if (element2.id == element.category.id) {
                            state.listKnowledge.push(element);
                        }
                    });
                });
            }
        };

        onMounted(getCategory);
        onMounted(getKnowledge);

        return {
            state,
            selectedBusinessId,
            search,
            select,
            selectChild,
            getCategory,
            selectCategory,
            unselectCategory,
            categoryForm,
            getKnowledge,
            filterKnowledge,
            selectInnerCategory,
            addCategory,
            editStatus,
            editCategoryName,
            deleteCategoryName,
            knowledgeShow,
            newKnowledge,
            addKnowledge,
            editKnowledge,
            deleteKnowledge
        };
    }
});
</script>
